* ENCRYPT.PRG
* This function will encrypt a file by using the RENAME command
* Two parameters required - filename and password
* This is configured for FoxPro 2.0 and 2.5/2.6 DOS
PARAMETER p_file, p_pass
IF PARAM() <> 2
	=CR_ERROR('Too few arguments.')
	RETURN .F.
ENDIF
IF 'WINDOWS' $ UPPER(VERS(1))
	WAIT WINDOW NOWAIT 'This is the DOS demo of Cryptor!'
	RETURN .F.
ENDIF
* save existing environment switches
SET CONSOLE OFF
PRIVATE m_talk, m_safe, m_ok, mFileName, mFilePath, mLibName
m_talk = SET('TALK')
m_safe = SET('SAFE')
m_ok = .F.
SET SAFE OFF
SET TALK OFF
SET CONSOLE ON
IF FILE(p_file) 
	* get the full path of this file
	mFileName = SYS(2014,FULLPATH(p_file),FULLPATH(p_file))
	mFilePath = STRTRAN(FULLPATH(p_file),mFileName)
	* check we have enough disk space to perform this procedure
	=ADIR(m_size,p_file)
	IF DISKSPACE() > m_size(1,2)
		* load the approprate cryptor library
		mLibName = IIF('2.0'$VERS(1), 'CRYPT20D', 'CRYPTORD')
		mLibExt  = IIF('WINDOWS' $ UPPER(VERS(1)), '.FLL', '.PLB')
		SET LIBRARY TO LOCFILE((mLibName+mLibExt), RIGHT(mLibExt,3), 'Please locate Cryptor Library '+mLibName+mLibExt)
		* get a temporary filename
		m_temp = mFilePath+SYS(3)+'.CRY'
		RENAME (p_file) TO (m_temp)
		* register the target file as encrypted with CRYPTOR
		=CRYPTOR(p_file,p_pass)
		* now encrypt it
		WAIT WINDOW 'Encrypting '+p_file+' Please wait...' NOWAIT
		RENAME (m_temp) TO (p_file)
		IF m_talk = 'ON'
			? UPPER(ALLTRIM(p_file))+' encrypted'
			? ''
		ENDIF
		WAIT CLEAR
		=CRYPTOFF(p_file)
		m_ok = .T.
	ELSE
		=CR_ERROR('Not enough diskspace to perform task.')
	ENDIF
ELSE
	=CR_ERROR('File does not exist.')
ENDIF
SET TALK &m_talk
SET SAFE &m_safe
RETURN m_ok

FUNCTION cr_error
PARAMETER p_message
DEFINE WINDOW w_error FROM SROW()-7,INT(SCOL()/2)-25 ;
						TO SROW()-2,INT(SCOL()/2)+24 ;
						DOUBLE SHADOW COLOR SCHEME 7
ACTIVATE WINDOW w_error
@ 1,(49-LEN(p_message))/2 SAY p_message
=INKEY(0)
RELEASE WINDOW w_error
RETURN